//+------------------------------------------------------------------+
//|                                                       FFT_MA_mod.mq4 |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_width1 2
#property indicator_color1 Red

//Imorting library #_lib_FFT.ex4. It must be in the expert directory. 
#import "#_lib_FFT.ex4"
void realfastfouriertransform(double& a[], int tnn, bool inversefft); 
#import

//Input parametersextern 
extern int n      =10;          // Sets the number of data points as 2^n.
extern int hmax   =10;   //      

//Global variables
int N;                  //N is number of data points.
//Indicator buffer
double FFTMA[];

int init()
{
N=MathPow(2,n);
if(hmax>N) hmax=N;
IndicatorBuffers(1);
SetIndexBuffer(0,FFTMA);
SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
IndicatorShortName("FFTMA");   
return(0);
}

int deinit(){return(0);}

int start()
{
double data[],data1[],energi_sign,energi_shum;
ArrayResize(data,N);
ArrayResize(data1,N);
for(int i=0;i<N;i++) data[i]=Close[i];
realfastfouriertransform(data,N,false);   //   CLOSE    512 
energi_sign=0; //  
energi_shum=0;
ArrayCopy(data1,data);                    //   ,     
ArraySort(data1,WHOLE_ARRAY,0,MODE_DESCEND); //  
//   
//          hmax
for(i=hmax;i<N;i++)   if (data[i]<data1[hmax]) data[i]=0.0; 
for(i=hmax;i<N;i++)  energi_sign=energi_sign+data[i];   //     ( )
// 
//      
for(i=hmax;i<N;i++)   if (data[i]>data1[hmax]) data[i]=0.0;
for(i=hmax;i<N;i++)  energi_shum=energi_shum+data[i];   //     ( )
/* 
realfastfouriertransform(data,N,true);   //  
ArrayInitialize(FFTMA,EMPTY_VALUE);   
for(i=0;i<N;i++)FFTMA[i]=data[i];   //   
*/
return(0);
}
//+------------------------------------------------------------------+
// !!!       !!!